/**********************************************************************
 * Philips USB Mass Storage Class driver Interface
 *
 * (c) 2002 Koninklijke Philips Electronics N.V., All rights reserved
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * File Name:   msbridge.h
 *
 * Refering linux kernel version 2.6.9
 *
 * History:     
 *
 * Date                Author                  Comments
 * ---------------------------------------------------------------------
 * Nov 29 2005        Prabhakar Kalasani        Initial Creation
 *
 ***********************************************************************/

#ifndef __DEVMSCD_INTF_H__ 
#define __DEVMSCD_INTF_H__

#define         MSCD_CMD_LEN            0x10
#define         MSCD_CMD                MSCD_COMMAND
#define         MSCD_RESET              MSCDBRIDGE_RESET

typedef struct mscd_notif {
    unsigned char       notif;          /* notification type */
} mscd_notif_t;


/* 
 * Mass storage command 
 */
typedef struct mscd_command {
    unsigned char       cmd[MSCD_CMD_LEN];
} mscd_command_t;

#define         MSCD_CMD_RES_SUCCESS    MSCD_SUCCESS
#define         MSCD_CMD_RES_FAILED     MSCD_FAILED
#define         MSCD_CMD_RES_ERROR      MSCD_ERROR

typedef struct mscd_cmd_res {
    unsigned char       status;         /* response of the command */
    unsigned long       residue;        /* data residue */
} mscd_cmd_res_t;

#define         DEVMSCD_MAJOR           18
#define         MSCD_IOC_MAGIC          'o'

#define         MSCD_IOC_GET_NOTIF      _IOR(MSCD_IOC_MAGIC, 0x10, mscd_notif_t)
#define         MSCD_IOC_GET_COMMAND    _IOR(MSCD_IOC_MAGIC, 0x11, mscd_command_t)
#define         MSCD_IOC_SET_CMD_RES    _IOW(MSCD_IOC_MAGIC, 0x12, mscd_cmd_res_t)

#include "mscdbridge.h"

#endif  /* __DEVMSCD_INTF_H__ */
