

#if defined(CONFIG_USB_ISP1761_MSCD) && !defined(CONFIG_USB_ISP1761_WOLFDEV)

    #define vendor_id        0x04CC
    #define product_id       0x1b41 /*0x1A64 */

    /* Unicode descriptors for our device description, we offer only one language: 0409, US English */
    unsigned char unicode_string[] __attribute__ ((aligned (4))) = { 0x04,0x03, 0x09,0x04 };

    unsigned char mfg_string[] __attribute__ ((aligned (4))) =  
        { 46,3,'P',0, 'h',0, 'i',0, 'l',0, 'i',0, 'p',0, 's',0,' ',0, 'S',0, 'e',0, 'm',0, 'i',0,'c',0, 'o',0, 'n',0, 'd',0, 'u',0, 'c',0, 't',0, 'o',0, 'r',0, 's',0 };

    unsigned char product_string[]__attribute__ ((aligned (4))) = 
        { 68,3,'1',0, '7',0, '6',0, '2',0, '-',0, 'O',0, 'T',0, 'G',0, ' ',0,'M',0, 'A',0, 'S',0, 'S',0, ' ',0,'S',0, 't',0, 'o',0, 'r',0, 'a',0, 'g',0, 'e',0, ' ',0,'P',0, 'X',0, 'A',0, '-',0, '2',0, '5',0, '0',0,' ',0, 'K',0, 'i',0, 't',0 };

    unsigned char serial_string[] __attribute__ ((aligned (4))) = {10, 3, '1', 0, '.',0, '0', 0, '0', 0 };

    /* Device descriptor */
    unsigned char device_desc[] __attribute__ ((aligned (4))) = {
        PDC_DEV_DESC_LEN,  /* length of this desc. */
        PDC_DEV_DESC_TYPE, /* DEVICE descriptor */
        0x10,0x01,         /* spec rev level (BCD) */
        0x00,              /* device class */
        0x00,              /* device subclass */
        0x00,              /* device protocol */  
        PDC_CTRL_MPS,      /* max packet size */
        (vendor_id & 0xFF),
        (vendor_id >> 8),
        (product_id & 0xFF),
        (product_id >> 8),
        0x00,0x01,         /* 1761's revision ID */  
        1,                 /* index of manuf. string */   
        2,                 /* index of prod.  string */  
        3,                 /* index of ser. # string */   
        PDC_BUS_NUM_CONFIG /* number of configs. */ 
    };

    unsigned char conf_desc[] __attribute__ ((aligned (4))) = {
        PDC_CONFIG_DESC_LEN,                /* length of this desc. */ 
        PDC_CONFIG_DESC_TYPE,       /* CONFIGURATION descriptor */  
    #ifdef CONFIG_USB_OTG 
        0x23,0x00,                  /* total length returned */ 
    #elif MTP_ENABLED
        0x27,0x00,                  /* total length returned if device is for MTP*/ 
    #else
        0x20, 0x00,    
    #endif /* CONFIG_USB_OTG  */
        PDC_BUS_NUM_INTF,           /* number of interfaces */ 
        0x01,                               /* number of this config */ 
        0x00,                       /* index of config. string */  
        0xC0,                       /* attr.: self powered */   
        0x01,                       /* we take no bus power */  

        PDC_INTF_DESC_LEN,          /* length of this desc. */  
        PDC_INTF_DESC_TYPE,         /* INTERFACE descriptor */  
        0x00,                       /* interface number */
        0x00,                       /* alternate setting */  
    #ifdef MTP_ENABLED
        0x03,
        0x00,
        0x00,
        0x00,	
    #else    
        0x02,                       /* # of (non 0) endpoints */ 
        0x08,                       /* interface class (Mass Storage)*/
        0x06,                       /* interface subclass (SCSI Transparent) */  
        0x50,                       /* interface protocol (BOT Protocol) */  
    #endif
        0x00,                       /* index of intf. string */ 

        /* Pipe 0 */
        PDC_EP_DESC_LEN,            /* length of this desc. */   
        PDC_EP_DESC_TYPE,           /* ENDPOINT descriptor */ 
        0x81,                        /* address (IN) */  
        0x02,                       /* attributes  (BULK) */    
        (PDC_CONFIG_PIPE_MPS&0xff),/* max packet size */
        (PDC_CONFIG_PIPE_MPS>>8),
        0,                          /* interval (ms) */

        /* Pipe 1 */ 
        PDC_EP_DESC_LEN,            /* length of this desc. */   
        PDC_EP_DESC_TYPE,           /* ENDPOINT descriptor*/ 
        0x01,                       /* address (OUT) */  
        0x02,                       /* attributes  (BULK) */    
        (PDC_CONFIG_PIPE_MPS&0xff),/* max packet size */
        (PDC_CONFIG_PIPE_MPS>>8),
        0,                                   /* interval (ms) */

    #ifdef MTP_ENABLED
        /* Pipe 2 */
        PDC_EP_DESC_LEN,                   /* length of this desc. 32*/
        PDC_EP_DESC_TYPE,           /* ENDPOINT descriptor 33*/
        0x82,                             /* address (IN)  34*/
        0x03,                           /* attributes  (Interrupt)  35*/
        (PDC_CONFIG_PIPE_MPS&0xff),/* max packet size 36*/
        (PDC_CONFIG_PIPE_MPS>>8),    //37
        0x10, 
    #endif      
    #ifdef CONFIG_USB_OTG 
        PDC_OTG_DESC_LEN,               /* length of this desc. */
        PDC_OTG_DESC_TYPE,              /* OTG descriptor */
        0x03,                             /* D1: HNP Support D0:SRP Support */
    #endif /* CONFIG_USB_OTG */
    };

    #define PDC_BUS_CONFIG_DESC_LEN sizeof(conf_desc[0]) 


    /*HS descriptor */

    /* HS Device descriptor */
    unsigned char HS_device_desc[] __attribute__ ((aligned (4))) = {
        PDC_DEV_DESC_LEN,  /* length of this desc. */
        PDC_DEV_DESC_TYPE, /* DEVICE descriptor */
        0x00,0x02,         /* spec rev level (BCD) */
        0x00,              /* device class */
        0x00,              /* device subclass */
        0x00,              /* device protocol */  
        PDC_CTRL_MPS,      /* max packet size */
        (vendor_id & 0xFF),
        (vendor_id >> 8),
        (product_id & 0xFF),
        (product_id >> 8),
        0x00,0x01,         /* 1761's revision ID */  
        1,                 /* index of manuf. string */   
        2,                 /* index of prod.  string */  
        3,                 /* index of ser. # string */   
        PDC_BUS_NUM_CONFIG /* number of configs. */ 
    };

    unsigned char HS_conf_desc[] __attribute__ ((aligned (4))) = {
        PDC_CONFIG_DESC_LEN,                /* length of this desc. */ 
        PDC_CONFIG_DESC_TYPE,       /* CONFIGURATION descriptor */  
    #ifdef CONFIG_USB_OTG 
        0x23,0x00,                  /* total length returned */ 
    #elif MTP_ENABLED
        0x27,0x00,                  /* total length returned  2,3*/
    #else
        0x20,0x00,                  /* total length returned */ 
    #endif /* CONFIG_USB_OTG  */
        PDC_BUS_NUM_INTF,           /* number of interfaces */ 
        0x01,                               /* number of this config */ 
        0x00,                       /* index of config. string */  
        0xC0,                       /* attr.: self powered */   
        0x20,                       /*we take no bus power */  

        PDC_INTF_DESC_LEN,          /* length of this desc. */  
        PDC_INTF_DESC_TYPE,         /* INTERFACE descriptor */  
        0x00,                       /* interface number */
        0x00,                       /* alternate setting */  
    #ifdef MTP_ENABLED    
        0x03,
        0x00,
        0x00,
        0x00,
    #else
        0x02,                       /* # of (non 0) endpoints */ 
        0x08,                       /* interface class (Mass Storage)*/
        0x06,                       /* interface subclass (SCSI Transparent) */  
        0x50,                       /* interface protocol (BOT Protocol) */  
    #endif    
        0x00,                       /* index of intf. string */ 

        /* Pipe 0 */
        PDC_EP_DESC_LEN,            /* length of this desc. */   
        PDC_EP_DESC_TYPE,           /* ENDPOINT descriptor */ 
        0x81,                     	 /* address (IN) */  
        0x02,                       /* attributes  (BULK) */    
        (PDC_CONFIG_PIPE_HS_MPS&0xff),/* max packet size */
        (PDC_CONFIG_PIPE_HS_MPS>>8),
        0,                          /* interval (ms) */

        /* Pipe 1 */ 
        PDC_EP_DESC_LEN,            /* length of this desc. */   
        PDC_EP_DESC_TYPE,           /* ENDPOINT descriptor*/ 
        0x01,                       /* address (OUT) */  
        0x02,                       /* attributes  (BULK) */    
        (PDC_CONFIG_PIPE_HS_MPS&0xff),/* max packet size */
        (PDC_CONFIG_PIPE_HS_MPS>>8),
        0,                                   /* interval (ms) */

    #ifdef MTP_ENABLED
        /* Pipe 2 */
        PDC_EP_DESC_LEN,                   /* length of this desc. 32*/
        PDC_EP_DESC_TYPE,           /* ENDPOINT descriptor 33*/
        0x82,                             /* address (IN)  34*/
        0x03,                           /* attributes  (Interrupt)  35*/
        (PDC_CONFIG_PIPE_MPS&0xff),/* max packet size 36*/
        (PDC_CONFIG_PIPE_MPS>>8),    //37
        0x10, 
    #endif      

    #ifdef CONFIG_USB_OTG 
        PDC_OTG_DESC_LEN,               /* length of this desc. */
        PDC_OTG_DESC_TYPE,              /* OTG descriptor */
        0x03,                                           /* D1: HNP Support D0:SRP Support */
    #endif /* CONFIG_USB_OTG */
    };


    /* ADDED: OTHER SPEED DESCRIPTOR */

    unsigned char other_desc[] __attribute__ ((aligned (4))) ={             /*It is UMS by default*/
        PDC_CONFIG_DESC_LEN,                /* length of this desc. */
        PDC_OTHER_DESC_TYPE,        /* CONFIGURATION descriptor */
    #ifdef CONFIG_USB_OTG
        0x23,0x00,                  /* total length returned */
    #elif MTP_ENABLED
        0x27,0x00,                  /* total length returned  2,3*/
    #else
        0x20,0x00,                  /* total length returned */
    #endif /* CONFIG_USB_OTG  */
        PDC_BUS_NUM_INTF,           /* number of interfaces */
        0x01,                               /* number of this config */
        0x00,                       /* index of config. string */
        0xc0,                       /* attr.: self powered */
        0x01,                       /* we take no bus power */  

        PDC_INTF_DESC_LEN,          /* length of this desc. */
        PDC_INTF_DESC_TYPE,         /* INTERFACE descriptor */
        0x00,                       /* interface number */
        0x00,
    #ifdef MTP_ENABLED    
        0x03,
        0x00,
        0x00,
        0x00,
    #else
        0x02,                       /* # of (non 0) endpoints */
        0x08,                       /* interface class (Mass Storage)*/
        0x06,                       /* interface subclass (SCSI Transparent) */
        0x50,                       /* interface protocol (BOT Protocol) */
    #endif    
        0x00,                       /* index of intf. string */

        /* Pipe 0 */
        PDC_EP_DESC_LEN,            /* length of this desc. */
        PDC_EP_DESC_TYPE,           /* ENDPOINT descriptor */
        0x81,    	                  /* address (IN) */ 
        0x02,                       /* attributes  (BULK) */
        (PDC_CONFIG_PIPE_MPS&0xff),/* max packet size */
        (PDC_CONFIG_PIPE_MPS>>8),
        0,                          /* interval (ms) */

        /* Pipe 1 */
        PDC_EP_DESC_LEN,            /* length of this desc. */
        PDC_EP_DESC_TYPE,           /* ENDPOINT descriptor*/
        0x01,                       /* address (OUT) */
        0x02,                       /* attributes  (BULK) */
        (PDC_CONFIG_PIPE_MPS&0xff),/* max packet size */
        (PDC_CONFIG_PIPE_MPS>>8),
        0                                   /* interval (ms) */
    #ifdef CONFIG_USB_OTG

            ,PDC_OTG_DESC_LEN               /* length of this desc. */
            ,PDC_OTG_DESC_TYPE              /* OTG descriptor */
            ,0x03
            ,
    #endif /* CONFIG_USB_OTG */
    };
    /*For high speed USB conf*/
    unsigned char HS_other_desc[] __attribute__ ((aligned (4))) = {
        PDC_CONFIG_DESC_LEN,                /* length of this desc. */
        PDC_OTHER_DESC_TYPE,        /* CONFIGURATION descriptor */
    #ifdef CONFIG_USB_OTG
        0x23,0x00,                  /* total length returned */
    #else
        0x20,0x00,                  /* total length returned */
    #endif /* CONFIG_USB_OTG  */
        PDC_BUS_NUM_INTF,           /* number of interfaces */
        0x01,                               /* number of this config */
        0x00,                       /* index of config. string */
        0xc0,                       /* attr.: self powered */
        0x01,                       /* we take no bus power */  

        PDC_INTF_DESC_LEN,          /* length of this desc. */
        PDC_INTF_DESC_TYPE,         /* INTERFACE descriptor */
        0x00,                       /* interface number */
        0x00,                       /* alternate setting */
        0x02,                       /* # of (non 0) endpoints */
        0x08,                       /* interface class (Mass Storage)*/
        0x06,                       /* interface subclass (SCSI Transparent) */
        0x50,                       /* interface protocol (BOT Protocol) */
        0x00,                       /* index of intf. string */

        /* Pipe 0 */
        PDC_EP_DESC_LEN,            /* length of this desc. */
        PDC_EP_DESC_TYPE,           /* ENDPOINT descriptor */
        0x81,                       /* address (IN) */  
        0x02,                       /* attributes  (BULK) */
        (PDC_CONFIG_PIPE_HS_MPS&0xff),/* max packet size */
        (PDC_CONFIG_PIPE_HS_MPS>>8),
        0,                          /* interval (ms) */

        /* Pipe 1 */
        PDC_EP_DESC_LEN,            /* length of this desc. */
        PDC_EP_DESC_TYPE,           /* ENDPOINT descriptor*/
        0x01,                       /* address (OUT) */
        0x02,                       /* attributes  (BULK) */
        (PDC_CONFIG_PIPE_HS_MPS&0xff),/* max packet size */
        (PDC_CONFIG_PIPE_HS_MPS>>8),
        0,                                   /* interval (ms) */

    #ifdef MTP_ENABLED
        /* Pipe 2 */
        PDC_EP_DESC_LEN,                   /* length of this desc. 32*/
        PDC_EP_DESC_TYPE,           /* ENDPOINT descriptor 33*/
        0x82,                             /* address (IN)  34*/
        0x03,                           /* attributes  (Interrupt)  35*/
        (PDC_CONFIG_PIPE_MPS&0xff),/* max packet size 36*/
        (PDC_CONFIG_PIPE_MPS>>8),    //37
        0x10, 
    #endif      

    #ifdef CONFIG_USB_OTG
        PDC_OTG_DESC_LEN,               /* length of this desc. */
        PDC_OTG_DESC_TYPE,              /* OTG descriptor */
        0x03,                                           /* D1: HNP Support D0:SRP Support */
    #endif /* CONFIG_USB_OTG */
    };



    /*HS descriptor */

    unsigned char Test_Packet[] __attribute__ ((aligned (4))) =
    {
        0xc3,
        0x00, 0x00,
        0x00, 0x00,
        0x00, 0x00,
        0x00, 0x00,
        0x00, 0xaa,
        0xaa, 0xaa,
        0xaa, 0xaa,
        0xaa, 0xaa,
        0xaa, 0xee,  
        0xee, 0xee,
        0xee, 0xee,
        0xee, 0xee,
        0xee, 0xfe,  
        0xff, 0xff,
        0xff, 0xff,
        0xff, 0xff,
        0xff, 0xff,
        0xff, 0xff,  
        0xff, 0x7f,
        0xbf, 0xdf,
        0xef, 0xf7,
        0xfb, 0xfd,
        0xfc, 0x7e,
        0xbf, 0xdf,
        0xef, 0xf7,
        0xfb, 0xfd,
        0x7e,
        0xb6, 0xce,  

    };

    unsigned char device_qualifier_desc[] __attribute__ ((aligned (4))) = {
        PDC_QUALIFIER_SIZE,
        PDC_CONFIG_QUALIFIER_TYPE,
        0x00,0x02,
        0,
        0,
        0,
        64,
        1,
        0
    };
#endif
